using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

using Syncfusion.Windows.Forms.Grid;


namespace GridUpdates
{
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonStart;
		private Syncfusion.Windows.Forms.Tools.NumericUpDownExt numericUpDownExtUpdateFrequency;
		private WorkerThread _model;
		private GridRangeInfo compositeUpdateRange = GridRangeInfo.Empty;
		private System.Windows.Forms.Timer timer;

		public Form1()
		{
			InitializeComponent();
			this.timer = new System.Windows.Forms.Timer();
			this.timer.Tick += new EventHandler(this.ForceUpdateGrid);

		}

		private void ForceUpdateGrid(object sender, EventArgs args)
		{
			if(this.compositeUpdateRange.IsEmpty)
				return;
			this.gridControl1.RefreshRange(this.compositeUpdateRange);
			this.compositeUpdateRange = GridRangeInfo.Empty;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.buttonStart = new System.Windows.Forms.Button();
			this.numericUpDownExtUpdateFrequency = new Syncfusion.Windows.Forms.Tools.NumericUpDownExt();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownExtUpdateFrequency)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.ColCount = 0;
			this.gridControl1.Location = new System.Drawing.Point(0, 0);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 0;
			this.gridControl1.Size = new System.Drawing.Size(480, 266);
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// buttonStart
			// 
			this.buttonStart.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.buttonStart.Location = new System.Drawing.Point(392, 280);
			this.buttonStart.Name = "buttonStart";
			this.buttonStart.TabIndex = 1;
			this.buttonStart.Text = "Start";
			this.buttonStart.Click += new System.EventHandler(this.buttonStart_Click);
			// 
			// numericUpDownExtUpdateFrequency
			// 
			this.numericUpDownExtUpdateFrequency.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownExtUpdateFrequency.BorderColor = System.Drawing.Color.Black;
			this.numericUpDownExtUpdateFrequency.Increment = new System.Decimal(new int[] {
																							  100,
																							  0,
																							  0,
																							  0});
			this.numericUpDownExtUpdateFrequency.Location = new System.Drawing.Point(296, 280);
			this.numericUpDownExtUpdateFrequency.Maximum = new System.Decimal(new int[] {
																							5000,
																							0,
																							0,
																							0});
			this.numericUpDownExtUpdateFrequency.Minimum = new System.Decimal(new int[] {
																							100,
																							0,
																							0,
																							0});
			this.numericUpDownExtUpdateFrequency.Name = "numericUpDownExtUpdateFrequency";
			this.numericUpDownExtUpdateFrequency.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownExtUpdateFrequency.TabIndex = 2;
			this.numericUpDownExtUpdateFrequency.Value = new System.Decimal(new int[] {
																						  100,
																						  0,
																						  0,
																						  0});
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 309);
			this.Controls.Add(this.numericUpDownExtUpdateFrequency);
			this.Controls.Add(this.buttonStart);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Grd Updates";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownExtUpdateFrequency)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		public void RefreshRows(GridRangeInfo updateRange)
		{
			this.compositeUpdateRange = this.compositeUpdateRange.UnionRange(updateRange);
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridControl1.ResetVolatileData();
			this.gridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
			this.gridControl1.QueryColCount += new GridRowColCountEventHandler(gridControl1_QueryColCount);
			this.gridControl1.QueryRowCount += new GridRowColCountEventHandler(gridControl1_QueryRowCount);

			_model = new WorkerThread(this, 1000, 20);
		}

		private void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = this._model.Cols;
			e.Handled = true;
		}

		private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = this._model.Rows;
			e.Handled = true;
		}

		private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				e.Style.CellValue = this._model[e.RowIndex, e.ColIndex];
				e.Handled = true;
			}
		}

		private void buttonStart_Click(object sender, System.EventArgs e)
		{
			_model.SleepTime = (int)this.numericUpDownExtUpdateFrequency.Value;
			Thread t1 = new Thread(new ThreadStart(this._model.Runner));
			t1.IsBackground = true;
			t1.Priority = ThreadPriority.Lowest;
			t1.Start();

			this.timer.Interval = 50;
			this.timer.Enabled = true;
			this.timer.Start();
		}

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
